public class Util {
  /**
   * 获取指定范围指定个数的随机数组成的数组
   *
   * @param length 长度
   * @param min 最小值
   * @param max 最大值
   * @return
   */
  public static int[] getRandomArr(int length, int min, int max) {
    int[] arr = new int[length];
    for (int i = 0; i < length; i++) {
      arr[i] = (int) (Math.random() * (max + 1 - min) + min);
    }
    return arr;
  }

  public static void printArr(int[] arr) {
    for (int e : arr) {
      System.out.print("" + e + '\t');
    }
    System.out.println();
  }

  /**
   * 对数组元素求和
   * @param arr
   * @return
   */
  public static int sum(int[] arr) {
    int total = 0;
    for (int e : arr) {
      total += e;
    }
    return total;
  }

  /**
   * 求平均值
   */
  public static double avg(int[] arr) {
    return sum(arr) / (double) arr.length;
  }

  /**
   * 求最大值
   * @param arr
   * @return
   */
  public static int max(int[] arr) {
    int max = arr[0];
    for (int i = 1; i < arr.length; i++) {
      if (arr[i] > max)
        max = arr[i];
    }
    return max;
  }

  /**
   * 求最小值
   * @param arr
   * @return
   */
  public static int min(int[] arr) {
    int min = arr[0];
    for (int i = 1; i < arr.length; i++) {
      if (arr[i] < min)
        min = arr[i];
    }
    return min;
  }

  public static void shuffle(int[] arr) {
    for (int i = arr.length - 1; i > 0; i--) {
      // 随机生成一个下标j 0 <= j <= i
      int j = (int) (Math.random() * (i + 1));
      // 交换 arr[i] 和 arr[j]
      int temp = arr[i];
      arr[i] = arr[j];
      arr[j] = temp;
    }
  }

  public static int indexOf(int[] arr, int target) {
    int res = -1;
    for (int i = 0; i < arr.length; i++) {
      if (arr[i] == target) {
        res = i;
        break;
      }
    }
    return res;
  }

  public static int binarySearch(int[] arr, int target) {
    //1.定左右标尺
    int left = 0;
    int right = arr.length - 1;
    //2.标尺不相错，一直循环：根据中值（a.算中值，b.和中值比较），调整标尺或返回结果
    while (left <= right) {//擦肩而过，就退出循环

      int midIndex = left + ((right - left) >> 1);
      int midValue = arr[midIndex];

      if (target > midValue) { //往右走
        left = midIndex + 1;
      } else if (target < midValue) {
        right = midIndex - 1;
      } else {
        return midIndex;
      }
    }
    return -1;
  }
/*
* 局面
* 外接给我的任务、参数，称为局面
* 经过一定的处理，变成一个新局面，
* */
  public static int binarySearch(int[] arr, int left, int right, int target) {

    int midIndex = left + ((right - left) >> 1);
    int midValue = arr[midIndex];

    if (target > midValue) {
      return binarySearch(arr, midIndex + 1, right, target);
    } else if (target < midValue) {
      return binarySearch(arr, left, midIndex - 1, target);
    } else {
      return midIndex;
    }
  }

  public static void swap(int[]arr,int i,int j){
    int temp = arr[i];
    arr[i]=arr[j];
    arr[j]=temp;
  }
}
